#include <windows.h>
#include <fcntl.h>
#include <stdio.h>
#include <glob.h>

static int pathes_returned;
static  glob_t globbuf;

/*************************************************************************
 *           FindFirstFile32A  (KERNEL32.123)
 */
HANDLE32 FindFirstFile32A( LPCSTR path, WIN32_FIND_DATA32A *data )
{
     unsigned int result;

     globbuf.gl_offs = 0;
     result= glob(path, GLOB_NOCHECK , NULL, &globbuf);
     if (result) {
       printf("FindFirstFile glob got error");
       switch (result) {
       case GLOB_NOSPACE:
	 printf("GLOB_NOSPACE\n");
	 break;
       case GLOB_ABEND:
	 printf("GLOB_ABEND\n");
	 break;
       case GLOB_NOMATCH:
	 printf("GLOB_NOMATCH\n");
	 break;
       default:
	 printf("UNKNOWN\n");
       }
       return INVALID_HANDLE_VALUE;
     }
     strcpy(data->cFileName,globbuf.gl_pathv[0]);
     pathes_returned = 1;
     return (HANDLE32)&globbuf;
}

     
/*************************************************************************
 *           FindNextFile32A   (KERNEL32.126)
 */
BOOL32 FindNextFile32A( HANDLE32 handle, WIN32_FIND_DATA32A *data )
{
    if (pathes_returned >=globbuf.gl_pathc)
      return FALSE;
    strcpy(data->cFileName,globbuf.gl_pathv[pathes_returned++]);
    return TRUE; 
}
/*************************************************************************
 *           FindClose32   (KERNEL32.119)
 */
BOOL32 FindClose32( HANDLE32 handle )
{
    globfree((void *)handle);
    return TRUE;
}

