#include <windows.h>
#include <stdio.h>
#include <winnls.h>
#include <unistd.h>
#include <string.h> 
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
  
#include <winerror.h>
#include <ctype.h>

/* MapViewOfFile */
#include <sys/mman.h>

#include <sys/errno.h> 

/*GetSystemTime*/
#include <utime.h>
#include <sys/time.h>

typedef struct {
    DWORD           count;
    void *          start;
    char *          name;
}               MAP_DESCRIPTIONS;
static int map_initializes=0;
#define no_of_maphandles 2048
static MAP_DESCRIPTIONS mapping_handles[no_of_maphandles];

static LastError=0;

/*strnicmp calls lstrncmpi32A taken from wine*/
INT32  strnicmp( LPCSTR str1, LPCSTR str2, INT32 n )
{
    INT32 res;
    if (!n) return 0;
    while ((--n > 0) && *str1)
      if ( (res = toupper(*str1++) - toupper(*str2++)) ) return res;
    return toupper(*str1) - toupper(*str2);
}

/***********************************************************************
 *           lstrcmpi32A   (KERNEL32.605) used as strcmpi
 */
INT32 strcmpi( LPCSTR str1, LPCSTR str2 )
{
    INT32 res;
    if (!str1 || !str2) {
        LastError=ERROR_INVALID_PARAMETER;
        return 0;
    }
    while (*str1)
    {
        if ((res = toupper(*str1) - toupper(*str2)) != 0) return res;
        str1++;
        str2++;
    }
    return toupper(*str1) - toupper(*str2);
}

/*********************************************************************
 *                  _strupr       (CRTDLL.300)
 */
LPSTR strupr(LPSTR x)
{
        LPSTR   y=x;
        while (*y) {
                *y=toupper(*y);
                y++;
        }
        return x;
}

/*GetACP needed by  WideCharToMultiByte */

/***********************************************************************
 *           lstrcpy32A   (KERNEL32.608)
 */
LPSTR lstrcpy32A( LPSTR dst, LPCSTR src )
{
    if (!src || !dst) return NULL;
    strcpy( dst, src );
    return dst;
}

/***********************************************************************
 *           lstrcpy32W   (KERNEL32.609)
 */
LPWSTR lstrcpy32W( LPWSTR dst, LPCWSTR src )
{
    register LPWSTR p = dst;
    /*    fprintf(stderr,"strcpy L%s\n", debugstr_w (src));*/
    while ((*p++ = *src++));
    return dst;
}


/***********************************************************************
 *           lstrlen32A   (KERNEL32.614)
 */
INT32 lstrlen32A( LPCSTR str )
{
    if (!str) return 0;
    return (INT32)strlen(str);
}

/***********************************************************************
 *           lstrlen32W   (KERNEL32.615)
 */
INT32  lstrlen32W( LPCWSTR str )
{
    INT32 len = 0;
    /*fprintf(stderr,"strlen L%s\n", debugstr_w (str));*/
    if (!str) return 0;
    while (*str++) len++;
    return len;
}


/*********************************************************************
 *                  _strlwr      (CRTDLL.293)
 *
 * convert a string in place to lowercase
 */
LPSTR strlwr(LPSTR x)
{
  unsigned char *y =x;
  while (*y) {
    if ((*y > 0x40) && (*y< 0x5b))
      *y = *y + 0x20;
    y++;
  }
  return x;
}
   

UINT32 GetACP(void)
{
    return 1252;    /* Windows 3.1 ISO Latin */
}

/*********************************************************************
 *                  mbstowcs           (CRTDLL.429)
 * FIXME: check multibyte support

 Unix mbstowcs uses unsigned long, Win32 unsigned short
 */
INT32 CRTDLL_mbstowcs(LPWSTR wcs, LPCSTR mbs, INT32 size)
{
/* Slightly modified lstrcpynAtoW functions from memory/strings.c
 *  We need the numberr of characters transfered
 *  FIXME: No multibyte support yet
 */
    LPWSTR p = wcs;
    LPCSTR src= mbs;
    int ret, n=size;
    while ((n-- > 0) && *src) {
      *p++ = (WCHAR)(unsigned char)*src++;
        }
    p++;
    ret = (p -wcs);
    return ret;
}

/* WideCharToMultiByte*/

int WideCharToMultiByte(UINT32 page, DWORD flags, WCHAR *src, int srclen,
                               char *dst, int dstlen, char* defchar, BOOL32 *used)
{
        int count = 0;
        int dont_copy= (dstlen==0);
        if(page!=GetACP() && page!=CP_OEMCP && page!=CP_ACP)
                fprintf(stderr,"Conversion in CP %d not supported\n",page);
#if 0        
	if(flags)
                fprintf(stdnimp,"WideCharToMultiByte flags %lx not supported\n",flags);
#endif
        if(used)
                *used=0;
        while(srclen && (dont_copy || dstlen))
        {
                if(!dont_copy){
                        if(*src<256)
                                *dst = *src;
                        else
                        {
                                /* FIXME: Is this correct ?*/
                                if(flags & WC_DEFAULTCHAR){
                                        *dst = defchar ? *defchar : '?';
                                        if(used)*used=1;
                                }
                        }
                        dstlen--;
                        dst++;
                }
                count++;
                if(!*src)
                        break;
                if(srclen!=-1)srclen--;
                src++;
        }
        return count;
}
/***********************************************************************
 *           lstrcmpi32W   (KERNEL32.606)
 */
INT32 lstrcmpi32W( LPCWSTR str1, LPCWSTR str2 )
{
    INT32 res;
#if 0
    /* Too much!  (From registry loading.)  */
    dprintf_string(stddeb,"strcmpi L%s and L%s\n",
                   debugstr_w (str1), debugstr_w (str2));
#endif
    if (!str1 || !str2) {
      /*SetLastError(ERROR_INVALID_PARAMETER);*/
        return 0;
    }
    while (*str1)
    {
        /* FIXME: Unicode */
        if ((res = toupper(*str1) - toupper(*str2)) != 0) return res;
        str1++;
        str2++;
    }
    return toupper(*str1) - toupper(*str2);
}

/*********************************************************************
 *                  _wcsicmp           (CRTDLL.321)
 */
DWORD _wcsicmp( LPCWSTR s1, LPCWSTR s2 )
{
    return lstrcmpi32W( s1, s2 );
}


 
static int TranslateCreationFlags(DWORD create_flags);
static int TranslateAccessFlags(DWORD access_flags);
/***********************************************************************
 *             WriteFile               (KERNEL32.578)
 */
BOOL32 WriteFile(HFILE32 hFile, LPVOID lpBuffer, DWORD numberOfBytesToWrite,
                        LPDWORD numberOfBytesWritten, LPOVERLAPPED lpOverlapped)
{
    LONG        res;
    res = write(hFile,lpBuffer,numberOfBytesToWrite);
    if (res==-1) {
        /*SetLastError(ErrnoToLastError(errno)); */
        return FALSE;
    }
    if(numberOfBytesWritten)
        *numberOfBytesWritten = res;
    return TRUE;
}

static int TranslateAccessFlags(DWORD access_flags)
{
    int rc = 0;
    switch(access_flags)
    {
        case GENERIC_READ:
            rc = O_RDONLY;
            break;
        case GENERIC_WRITE:
            rc = O_WRONLY;
            break;
        case (GENERIC_READ | GENERIC_WRITE):
            rc = O_RDWR;
            break;
    }
    return rc;
}

static int TranslateCreationFlags(DWORD create_flags)
{
    int rc = 0;
    switch(create_flags)
    {
        case CREATE_NEW:
            rc = O_CREAT | O_EXCL;
            break;
        case CREATE_ALWAYS:
            rc = O_CREAT | O_TRUNC;
            break;
        case OPEN_EXISTING:
            rc = 0;
            break;
        case OPEN_ALWAYS:
            rc = O_CREAT;
            break;
        case TRUNCATE_EXISTING:
            rc = O_TRUNC;
            break;
    }
    return rc;
}

HFILE32 CreateFile32A(LPCSTR filename, DWORD access, DWORD sharing,
                             LPSECURITY_ATTRIBUTES security, DWORD creation,
                             DWORD attributes, HANDLE32 template)
{
    HFILE32 ret;
    char * myname;

    int access_flags, create_flags;
    /* Translate the various flags to Unix-style.
     */
    access_flags = TranslateAccessFlags(access);
    create_flags = TranslateCreationFlags(creation);
    /* Substitute '/' for '\\' */
    for (myname = (char*)filename; *myname; myname++) 
      if (*myname == '\\') *myname = '/';
    if(template)
      fprintf(stderr, "CreateFile: template handles not supported.\n");
    /* If the name starts with '\\?' or '\\.', ignore the first 3 chars.
     */
    if(!strncmp(filename, "\\\\?", 3) || !strncmp(filename, "\\\\.", 3))
        filename += 3;
    /* If the name still starts with '\\', it's a UNC name.
     */
    if(!strncmp(filename, "\\\\", 2))
    {
        fprintf(stderr, "CreateFile: UNC names not supported.\n");
	LastError= ERROR_CALL_NOT_IMPLEMENTED;
        return HFILE_ERROR32;
    }
    myname = (char*)malloc(strlen(filename)+1);
    if (!myname)
      {
	fprintf(stderr,"CreateFile no room for malloc\n");
	return HFILE_ERROR32;
      }
    else
      {
	strcpy (myname,filename);
      }
    ret= open( filename, access_flags | create_flags ,0666);
    LastError=errno;
    if (ret == -1) return HFILE_ERROR32;
    mapping_handles[ret].name  = myname;
    return ret;
}

/***********************************************************************
 *           _lread32   (KERNEL32.596)
 */
UINT32 WINAPI _lread32( HFILE32 hFile, LPVOID buffer, UINT32 count )
{

    if (!count) return 0;
    return read( hFile, buffer, count );
}

BOOL32  CloseHandle( HANDLE32 handle )
{

  if (mapping_handles[handle].start) /* is is mapped */
    {
      mapping_handles[handle].start =0;
      mapping_handles[handle].count =0;
      mapping_handles[handle].name  =0;
    }
  else 
    {
      free(mapping_handles[handle].name);
      close(handle);
    }
  return TRUE;
}

/***********************************************************************
 *           SetFilePointer   (KERNEL32.492)
 */
DWORD SetFilePointer( HFILE32 hFile, LONG distance, LONG *highword,
                             DWORD method )
{
    int origin, result;
    if (highword && *highword)
    {
        fprintf( stderr, "SetFilePointer: 64-bit offsets not supported yet\n");
        /*SetLastError( ERROR_INVALID_PARAMETER );*/
        return 0xffffffff;
    }
    switch(method)
    {
        case FILE_CURRENT: origin = SEEK_CUR; break;
        case FILE_END:     origin = SEEK_END; break;
        default:           origin = SEEK_SET; break;
    }
    result = lseek( hFile, distance, origin );
    return (DWORD)result;
}
/***********************************************************************
 *           GetFileSize   (KERNEL32.220)
 */
DWORD GetFileSize( HFILE32 hFile, LPDWORD filesizehigh )
{
    BY_HANDLE_FILE_INFORMATION info;
    if (!GetFileInformationByHandle( hFile, &info )) return 0;
    if (filesizehigh) *filesizehigh = info.nFileSizeHigh;
    return info.nFileSizeLow;
}



HANDLE32 CreateFileMapping32A(HFILE32 hFile, LPSECURITY_ATTRIBUTES attr,
                                     DWORD protect, DWORD size_high,
                                     DWORD size_low, LPCSTR name )
{
  int i;


  if (!map_initializes) /* initialize the mapping array */
    for( i=0; i<no_of_maphandles; i++) 
      {
	mapping_handles[i].start =0;
	mapping_handles[i].count =0;
      }

  return hFile;
}

/* Per-page protection byte values */
#define VPROT_READ       0x01
#define VPROT_WRITE      0x02
#define VPROT_EXEC       0x04
#define VPROT_WRITECOPY  0x08
#define VPROT_GUARD      0x10
#define VPROT_NOCACHE    0x20
#define VPROT_COMMITTED  0x40

/*from winbase.h*/
#define FILE_MAP_ALL_ACCESS             0x000f001f
 
LPVOID MapViewOfFile( HANDLE32 mapping, DWORD access, DWORD offset_high,
                             DWORD offset_low, DWORD count )
{
    int flags = MAP_PRIVATE;
    int prot = PROT_READ, mapcount;
    LPVOID ret;
    int current = lseek( mapping, 0, SEEK_CUR );

    if (!count) /* determin file length */
      {
	mapcount = lseek( mapping, 0,SEEK_END);
	lseek (mapping, current, SEEK_SET);
      }
    else
      mapcount = count;
 
    if (offset_high)
        fprintf( stderr, "MapViewOfFileEx: offsets larger than 4Gb not supported\n");
 
    switch(access)
    {
    case FILE_MAP_ALL_ACCESS:
    case FILE_MAP_WRITE:
         prot = PROT_WRITE;
    case FILE_MAP_WRITE | FILE_MAP_READ:
        flags = MAP_SHARED;
        /* fall through */
    case FILE_MAP_READ:
    case FILE_MAP_COPY:
    case FILE_MAP_COPY | FILE_MAP_READ:
        break;
        /* fall through */
    default:
        fprintf(stderr,"MapViewOfFile  ERROR_INVALID_PARAMETER\n");
        return 0;
    }

    ret =mmap( (void *)offset_low, mapcount, prot, flags, mapping, offset_low );
    
    if ((int)ret != -1)
      {
	mapping_handles[mapping].start = ret;
	mapping_handles[mapping].count = mapcount;
      }
    else
      fprintf(stderr,"MapViewOfFile mmap failed\n");
    return ret;
}
 
BOOL32 UnmapViewOfFile( LPVOID addr )
{
    int i;
    BOOL32 ret = -1;

    for(i=0; i<=no_of_maphandles; i++)
      if (mapping_handles[i].start == addr) 
	{
	  ret = munmap(mapping_handles[i].start,mapping_handles[i].count);
	  break;
	}
    return ((ret)?FALSE:TRUE);
  
}

/***********************************************************************
 *             IsBadReadPtr32   (KERNEL32.354)
 */
BOOL32  IsBadReadPtr32( LPCVOID ptr, UINT32 size )
{
   return 0;
}
 
/***********************************************************************
 *           SetConsoleCtrlHandler               (KERNEL32.459)
 */
BOOL32 SetConsoleCtrlHandler(void * func,  BOOL32 a)
{
        return 0;
}
/***********************************************************************
 *              GetSystemTime            (KERNEL32.285)
 */
VOID GetSystemTime(LPSYSTEMTIME systime)
{
    time_t local_time;
    struct tm *local_tm;
    struct timeval tv;
    gettimeofday(&tv, NULL);
    local_time = tv.tv_sec;
    local_tm = gmtime(&local_time);
    systime->wYear = local_tm->tm_year + 1900;
    systime->wMonth = local_tm->tm_mon + 1;
    systime->wDayOfWeek = local_tm->tm_wday;
    systime->wDay = local_tm->tm_mday;
    systime->wHour = local_tm->tm_hour;
    systime->wMinute = local_tm->tm_min;
    systime->wSecond = local_tm->tm_sec;
    systime->wMilliseconds = (tv.tv_usec / 1000) % 1000;
}
 
BOOL32  CreateProcess32A(
        LPCSTR appname,LPSTR cmdline,LPSECURITY_ATTRIBUTES processattributes,
        LPSECURITY_ATTRIBUTES threadattributes,BOOL32 inherithandles,
        DWORD creationflags,LPVOID env,LPCSTR curdir,
        LPSTARTUPINFO32A startupinfo,LPPROCESS_INFORMATION processinfo
) {
        fprintf(stderr,"CreateProcess(%s,%s,%p,%p,%d,%08lx,%p,%s,%p,%p)\n",
                appname,cmdline,processattributes,threadattributes,
                inherithandles,creationflags,env,curdir,startupinfo,processinfo
        );
        /* make from lcc uses system as fallback if CreateProcess returns
           FALSE, so return false */
        return FALSE;
}
 
DWORD WaitForSingleObject(HANDLE32 h, DWORD timeout)
{
        return 0;
}
 
/**********************************************************************
 *           GetLastError   (KERNEL.148) (KERNEL32.227)
 */
DWORD GetLastError(void)
{
    return LastError;
}
 


/***********************************************************************
 *           DOSFS_UnixTimeToFileTime
 *
 * Convert a Unix time to FILETIME format.
 * The FILETIME structure is a 64-bit value representing the number of
 * 100-nanosecond intervals since January 1, 1601, 0:00.
 * 'remainder' is the nonnegative number of 100-ns intervals
 * corresponding to the time fraction smaller than 1 second that
 * couldn't be stored in the time_t value.
 */
void DOSFS_UnixTimeToFileTime( time_t unix_time, FILETIME *filetime,
                               DWORD remainder )
{
    /* NOTES:
       CONSTANTS:
       The time difference between 1 January 1601, 00:00:00 and
       1 January 1970, 00:00:00 is 369 years, plus the leap years
       from 1604 to 1968, excluding 1700, 1800, 1900.
       This makes (1968 - 1600) / 4 - 3 = 89 leap days, and a total
       of 134774 days.
       Any day in that period had 24 * 60 * 60 = 86400 seconds.
       The time difference is 134774 * 86400 * 10000000, which can be written
       116444736000000000
       27111902 * 2^32 + 3577643008
       413 * 2^48 + 45534 * 2^32 + 54590 * 2^16 + 32768
       If you find that these constants are buggy, please change them in all
       instances in both conversion functions.
       VERSIONS:
       There are two versions, one of them uses long long variables and
       is presumably faster but not ISO C. The other one uses standard C
       data types and operations but relies on the assumption that negative
       numbers are stored as 2's complement (-1 is 0xffff....). If this
       assumption is violated, dates before 1970 will not convert correctly.
       This should however work on any reasonable architecture where WINE
       will run. 

       DETAILS:
       Take care not to remove the casts. I have tested these functions
       (in both versions) for a lot of numbers. I would be interested in
       results on other compilers than GCC.
       The operations have been designed to account for the possibility
       of 64-bit time_t in future UNICES. Even the versions without
       internal long long numbers will work if time_t only is 64 bit.
       A 32-bit shift, which was necessary for that operation, turned out
       not to work correctly in GCC, besides giving the warning. So I
       used a double 16-bit shift instead. Numbers are in the ISO version
       represented by three limbs, the most significant with 32 bit, the
       other two with 16 bit each.
       As the modulo-operator % is not well-defined for negative numbers,
       negative divisors have been avoided in DOSFS_FileTimeToUnixTime.
       There might be quicker ways to do this in C. Certainly so in
       assembler.
       Claus Fischer, fischer@iue.tuwien.ac.at
       */
#if __GNUC__
#  define USE_LONG_LONG 1
#else
#  define USE_LONG_LONG 0
#endif
#if USE_LONG_LONG               /* gcc supports long long type */
    long long int t = unix_time;
    t *= 10000000;
    t += 116444736000000000LL;
    t += remainder; 
    filetime->dwLowDateTime  = (UINT32)t;
    filetime->dwHighDateTime = (UINT32)(t >> 32);
#else  /* ISO version */
    UINT32 a0;                  /* 16 bit, low    bits */
    UINT32 a1;                  /* 16 bit, medium bits */
    UINT32 a2;                  /* 32 bit, high   bits */
    /* Copy the unix time to a2/a1/a0 */
    a0 =  unix_time & 0xffff;
    a1 = (unix_time >> 16) & 0xffff;
    /* This is obsolete if unix_time is only 32 bits, but it does not hurt.
       Do not replace this by >> 32, it gives a compiler warning and it does
       not work. */
    a2 = (unix_time >= 0 ? (unix_time >> 16) >> 16 :
          ~((~unix_time >> 16) >> 16));
    /* Multiply a by 10000000 (a = a2/a1/a0)
       Split the factor into 10000 * 1000 which are both less than 0xffff. */
    a0 *= 10000;
    a1 = a1 * 10000 + (a0 >> 16);
    a2 = a2 * 10000 + (a1 >> 16);
    a0 &= 0xffff;
    a1 &= 0xffff;
    a0 *= 1000;
    a1 = a1 * 1000 + (a0 >> 16);
    a2 = a2 * 1000 + (a1 >> 16);
    a0 &= 0xffff;
    a1 &= 0xffff;
    /* Add the time difference and the remainder */
    a0 += 32768 + (remainder & 0xffff);
    a1 += 54590 + (remainder >> 16   ) + (a0 >> 16);
    a2 += 27111902                     + (a1 >> 16);
    a0 &= 0xffff;
    a1 &= 0xffff;
    /* Set filetime */
    filetime->dwLowDateTime  = (a1 << 16) + a0;
    filetime->dwHighDateTime = a2;
#endif
} 

/***********************************************************************
 *           DOSFS_FileTimeToUnixTime
 *
 * Convert a FILETIME format to Unix time.
 * If not NULL, 'remainder' contains the fractional part of the filetime,
 * in the range of [0..9999999] (even if time_t is negative).
 */
time_t DOSFS_FileTimeToUnixTime( const FILETIME *filetime, DWORD *remainder )
{
    /* Read the comment in the function DOSFS_UnixTimeToFileTime. */
#if USE_LONG_LONG
    long long int t = filetime->dwHighDateTime;
    t <<= 32;
    t += (UINT32)filetime->dwLowDateTime;
    t -= 116444736000000000LL;
    if (t < 0)
    {
        if (remainder) *remainder = 9999999 - (-t - 1) % 10000000;
        return -1 - ((-t - 1) / 10000000);
    }
    else
    {
        if (remainder) *remainder = t % 10000000;
        return t / 10000000;
    }
#else  /* ISO version */
    UINT32 a0;                  /* 16 bit, low    bits */
    UINT32 a1;                  /* 16 bit, medium bits */
    UINT32 a2;                  /* 32 bit, high   bits */
    UINT32 r;                   /* remainder of division */
    unsigned int carry;         /* carry bit for subtraction */
    int negative;               /* whether a represents a negative value */
    /* Copy the time values to a2/a1/a0 */
    a2 =  (UINT32)filetime->dwHighDateTime;
    a1 = ((UINT32)filetime->dwLowDateTime ) >> 16;
    a0 = ((UINT32)filetime->dwLowDateTime ) & 0xffff;
    /* Subtract the time difference */
    if (a0 >= 32768           ) a0 -=             32768        , carry = 0;
    else                        a0 += (1 << 16) - 32768        , carry = 1; 

    if (a1 >= 54590    + carry) a1 -=             54590 + carry, carry = 0;
    else                        a1 += (1 << 16) - 54590 - carry, carry = 1;
    a2 -= 27111902 + carry;
    /* If a is negative, replace a by (-1-a) */
    negative = (a2 >= ((UINT32)1) << 31);
    if (negative)
    {
        /* Set a to -a - 1 (a is a2/a1/a0) */
        a0 = 0xffff - a0;
        a1 = 0xffff - a1;
        a2 = ~a2;
    }
    /* Divide a by 10000000 (a = a2/a1/a0), put the rest into r.
       Split the divisor into 10000 * 1000 which are both less than 0xffff. */
    a1 += (a2 % 10000) << 16;
    a2 /=       10000;
    a0 += (a1 % 10000) << 16;
    a1 /=       10000;
    r   =  a0 % 10000;
    a0 /=       10000;
    a1 += (a2 % 1000) << 16;
    a2 /=       1000;
    a0 += (a1 % 1000) << 16;
    a1 /=       1000;
    r  += (a0 % 1000) * 10000;
    a0 /=       1000;
 
    /* If a was negative, replace a by (-1-a) and r by (9999999 - r) */
    if (negative)
    {
        /* Set a to -a - 1 (a is a2/a1/a0) */
        a0 = 0xffff - a0;
        a1 = 0xffff - a1;
        a2 = ~a2;
        r  = 9999999 - r;
    }
    if (remainder) *remainder = r;
    /* Do not replace this by << 32, it gives a compiler warning and it does
       not work. */
    return ((((time_t)a2) << 16) << 16) + (a1 << 16) + a0;
#endif
}
/***********************************************************************
 *           FILE_FillInfo
 *
 * Fill a file information from a struct stat.
 */
static void FILE_FillInfo( struct stat *st, BY_HANDLE_FILE_INFORMATION *info )
{
    if (S_ISDIR(st->st_mode))
        info->dwFileAttributes = FILE_ATTRIBUTE_DIRECTORY;
    else
        info->dwFileAttributes = FILE_ATTRIBUTE_ARCHIVE;
    if (!(st->st_mode & S_IWUSR))
        info->dwFileAttributes |= FILE_ATTRIBUTE_READONLY;
    DOSFS_UnixTimeToFileTime( st->st_mtime, &info->ftCreationTime, 0 );
    DOSFS_UnixTimeToFileTime( st->st_mtime, &info->ftLastWriteTime, 0 );
    DOSFS_UnixTimeToFileTime( st->st_atime, &info->ftLastAccessTime, 0 );
    info->dwVolumeSerialNumber = 0;  /* FIXME */
    info->nFileSizeHigh = 0;
    info->nFileSizeLow  = S_ISDIR(st->st_mode) ? 0 : st->st_size;
    info->nNumberOfLinks = st->st_nlink;
    info->nFileIndexHigh = 0;
    info->nFileIndexLow  = st->st_ino;
}
/***********************************************************************
 *             GetFileInformationByHandle   (KERNEL32.219)
 */
DWORD GetFileInformationByHandle( HFILE32 hFile,
                                         BY_HANDLE_FILE_INFORMATION *info )
{
    DWORD ret = 0;
    struct stat st;
    if (!info) return 0;
    if (fstat( hFile, &st ) == -1) LastError=errno;
    else
    {
        FILE_FillInfo( &st, info );
        ret = 1;
    }
    return ret;
}
 
/***********************************************************************
 *           GetFileTime   (KERNEL32.221)
 */
BOOL32 GetFileTime( HFILE32 hFile, FILETIME *lpCreationTime,
                           FILETIME *lpLastAccessTime,
                           FILETIME *lpLastWriteTime )
{
    BY_HANDLE_FILE_INFORMATION info;
    if (!GetFileInformationByHandle( hFile, &info )) return FALSE;
    if (lpCreationTime)   *lpCreationTime   = info.ftCreationTime;
    if (lpLastAccessTime) *lpLastAccessTime = info.ftLastAccessTime;
    if (lpLastWriteTime)  *lpLastWriteTime  = info.ftLastWriteTime;
    return TRUE;
}

/***********************************************************************
 *           FileTimeToSystemTime   (KERNEL32.113)
 */
BOOL32 FileTimeToSystemTime( const FILETIME *ft, LPSYSTEMTIME syst )
{
    struct tm *xtm;
    DWORD remainder;
    time_t xtime = DOSFS_FileTimeToUnixTime( ft, &remainder );
    xtm = gmtime(&xtime);
    syst->wYear         = xtm->tm_year;
    syst->wMonth        = xtm->tm_mon;
    syst->wDayOfWeek    = xtm->tm_wday;
    syst->wDay          = xtm->tm_mday;
    syst->wHour         = xtm->tm_hour;
    syst->wMinute       = xtm->tm_min;
    syst->wSecond       = xtm->tm_sec;
    syst->wMilliseconds = remainder / 10000;
    return TRUE;
}
 
/***********************************************************************
 *           SystemTimeToFileTime   (KERNEL32.526)
 */
BOOL32 SystemTimeToFileTime( const SYSTEMTIME *syst, LPFILETIME ft )
{
    struct tm xtm;
    xtm.tm_year = syst->wYear;
    xtm.tm_mon  = syst->wMonth;
    xtm.tm_wday = syst->wDayOfWeek;
    xtm.tm_mday = syst->wDay;
    xtm.tm_hour = syst->wHour;
    xtm.tm_min  = syst->wMinute;
    xtm.tm_sec  = syst->wSecond;
    DOSFS_UnixTimeToFileTime( mktime(&xtm), ft, syst->wMilliseconds * 10000 );
    return TRUE;
}
/***********************************************************************
 *              SetFileTime   (KERNEL32.493)
 */
BOOL32 SetFileTime( HFILE32 hFile,
                           const FILETIME *lpCreationTime,
                           const FILETIME *lpLastAccessTime,
                           const FILETIME *lpLastWriteTime )
{
    struct utimbuf utimbuf;
    fprintf(stderr,"SetFileTime(%s,%p,%p,%p)\n",
        mapping_handles[hFile].name,
        lpCreationTime,
        lpLastAccessTime,
        lpLastWriteTime
    );
    if (lpLastAccessTime)
        utimbuf.actime  = DOSFS_FileTimeToUnixTime(lpLastAccessTime, NULL);
    else
        utimbuf.actime  = 0; /* FIXME */
    if (lpLastWriteTime)
        utimbuf.modtime = DOSFS_FileTimeToUnixTime(lpLastWriteTime, NULL);
    else
        utimbuf.modtime = 0; /* FIXME */
    if (-1==utime(mapping_handles[hFile].name,&utimbuf))
    {
        LastError=errno;
        return FALSE;
    }
    return TRUE;
}
HGLOBAL32  GlobalAlloc32(unsigned int type,unsigned long count)
{
  void* ret;

  ret = malloc(count);
  if (!ret) return (HGLOBAL32)ret;
  if (type & GMEM_ZEROINIT) {
    type &= ~GMEM_ZEROINIT;
    memset(ret,0,count);
  }
  if (type)
    printf("Unimplemented type 0x%04x in GlobalAlloc32\n",type);
  return (HGLOBAL32)ret;
}
/***********************************************************************
 *              ReadFile                (KERNEL32.428)
 */
BOOL32 ReadFile(HFILE32 hFile, LPVOID lpBuffer, DWORD numtoread,
                       LPDWORD numread, LPOVERLAPPED lpOverlapped)
{
    int actual_read;
    actual_read = read(hFile,lpBuffer,numtoread);
    if(actual_read == -1) {
        LastError=errno;
        return FALSE;
    }
    if(numread)
        *numread = actual_read;
    return TRUE;
}
/***********************************************************************
 *           FILE_Stat
 *
 * Stat a Unix path name. Return TRUE if OK.
 */
BOOL32 FILE_Stat( LPCSTR unixName, BY_HANDLE_FILE_INFORMATION *info )
{
    struct stat st;
    if (!unixName || !info) return FALSE;
    if (stat( unixName, &st ) == -1)
    {
        LastError=errno;
        return FALSE;
    }
    FILE_FillInfo( &st, info );
    return TRUE;
}

/**************************************************************************
 *           GetFileAttributes32A   (KERNEL32.217)
 */
DWORD WINAPI GetFileAttributes32A( LPCSTR name )
{
    BY_HANDLE_FILE_INFORMATION info;
    if (name == NULL) return -1;
    if (!FILE_Stat( name, &info )) return -1;
    return info.dwFileAttributes;
}
 
/***********************************************************************
 *           GetCurrentDirectory32A   (KERNEL32.196)
 *
 * Returns "/path/".
 */
UINT32 GetCurrentDirectory32A( UINT32 buflen, LPSTR buf )
{
    char *p;
    UINT32 ret;

    p=getcwd(buf,buflen);
    if (!p)
      {
	p = getcwd(NULL,0);
	ret = strlen(p);
	free(p);
      }
    else 
      ret= strlen(buf);
	
    return ret;
}
 
/***********************************************************************
 *         GetUserDefaultLangID       (OLE2NLS.3)
 */
LANGID GetUserDefaultLangID()
{
        return 0x09;                   /* English*/ 
}
 
/*********************************************************************
 *                  _lrotl          (CRTDLL.176)
 */
DWORD _lrotl(DWORD x,INT32 shift)
{
   unsigned long ret = (x >> shift)|( x >>((sizeof(x))-shift));

   return ret;
    
}
/***********************************************************************
 *           wsprintf32A   (USER32.585)
 */
INT32 WINAPIV wsprintf32A( LPSTR buffer, LPCSTR spec, ... )
{
    va_list valist;
    INT32 res;
    /*fprintf(stderr,"wsprintf32A for %p got ",buffer);*/
    va_start( valist, spec );
    res = vsprintf( buffer, spec, valist );
    va_end( valist );
    return res;
}

/**********************************************************************
 *           SetThreadPriority   (KERNEL32.514)
 */
BOOL32 SetThreadPriority(HANDLE32 hthread,INT32 priority)
{
    return TRUE;
}
 
/***********************************************************************
 *           GetCurrentThread   (KERNEL32.200)
 */
HANDLE32 GetCurrentThread(void)
{
    return 0xFFFFFFFE;
}

/***********************************************************************
 *           GlobalFree32   (KERNEL32.322)
 */
HGLOBAL32 GlobalFree32(HGLOBAL32 hmem)
{
   free((void*)hmem);
   return 0;
}

/***********************************************************************
 *           GlobalReAlloc32   (KERNEL32.328)
 */
HGLOBAL32 WINAPI GlobalReAlloc32(HGLOBAL32 hmem, DWORD size, UINT32 flags)
{
 return (unsigned int)realloc((void*)hmem,size);
}
